#!/bin/bash


g10s_LIBFILE=${g10s_LIBFILE="../globalLib/g10s_pub"}
if [ -f "${g10s_LIBFILE}" ]
then
	. "${g10s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g10s_LIBFILE}]\033[0m"
	exit 1
fi


t120s_backList=${t120s_backList:="${g10s_bakPath}/t120s_action.lst"}


function t120s_backup()
{
    if [ -f "$1" ]
    then
        print_debug "backup file[$1 to $2]"
        g10s_bakFileForce "$1" "$2" "t120s" "${t120s_backList}"
    fi
    return 0
}



print_debug "begin backup UltraPath files.[\$1=$1,t120s_backList=${t120s_backList}]"
if [ "$1" = "" ]
then
    print_error "1002" "$0 need a param to describe this backup action."
    exit 1
fi
if [ ! -f "${t120s_backList}" ]
then
    touch "${t120s_backList}"
fi

t120s_backDate=`date +%Y%m%d%H%M%S`
echo "###begin backup###$1###${t120s_backDate}###">>"${t120s_backList}"

t120s_backup "/etc/up.conf" "${g10s_bakPath}/up.conf"
t120s_backup "${g10s_ultraPathPackagesInfo}" "${g10s_bakPath}/UltraPath.packages.info"
t120s_backup "/etc/init.d/boot.udev" "${g10s_bakPath}/boot.udev"
t120s_backup "/boot/grub/menu.lst" "${g10s_bakPath}/menu.lst"
t120s_backup "/etc/lilo.conf" "${g10s_bakPath}/lilo.conf"
t120s_backup "/etc/elilo.conf" "${g10s_bakPath}/elilo.conf"
t120s_backup "/etc/rc.d/rc.sysinit" "${g10s_bakPath}/rc.sysinit"
t120s_backup "/usr/sbin/mkinitramfs" "${g10s_bakPath}/mkinitramfs"
t120s_backup "/sbin/mkinitrd" "${g10s_bakPath}/mkinitrd"
t120s_backup "/etc/sysconfig/kernel" "${g10s_bakPath}/kernel"
t120s_backup "/lib/mkinitrd/scripts/setup-start.sh" "${g10s_bakPath}/setup-start.sh"




echo "###end backup###$1###${t120s_backDate}###">>"${t120s_backList}"




