#!/bin/bash

g10s_LIBFILE=${g10s_LIBFILE="../globalLib/g10s_pub"}
if [ -f "${g10s_LIBFILE}" ]
then
	. "${g10s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g10s_LIBFILE}]\033[0m"
	exit 1
fi


g60s_LIBFILE=${g60s_LIBFILE="../globalLib/g60s_getHBAmodule"}
if [ -f "${g60s_LIBFILE}" ]
then
	. "${g60s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g60s_LIBFILE}]\033[0m"
	exit 1
fi


t180s_action=""
t180s_type=""
t180s_modprobeConfName=""
readonly t180s_allTypes=",SUSE11,SUSE10,REDHAT5,"


readonly t180s_mkinitrdFile="/sbin/mkinitrd"


t180s_setupStart=${t180s_setupStart:="/lib/mkinitrd/scripts/setup-start.sh"}
t180s_setupStartBak=${t180s_setupStartBak:="${g10s_bakPath}/t180s_setup-start.sh.bak"}
t180s_setupStartBeforeRemove=${t180s_setupStartBak:="${g10s_bakPath}/t180s_setup-start.sh.beforeRemove"}

readonly t180s_setupStartTmp="${g10s_tmpPath}/t180s_setup-start.sh.tmp"
readonly t180s_UltraPathFlag="###UltraPath t180s,don't change this!###"
readonly t180s_setupFile="/lib/mkinitrd/setup/32-nxupCopyUPConf.sh"
readonly t180s_beginFlag="###UltraPath t180s-begin,don't change this!###"
readonly t180s_endFlag="###UltraPath t180s-end,don't change this!###"


t180s_mkinitrdTmp="${g10s_tmpPath}/t180s_mkinitrd.tmp"
t180s_mkinitrdBak=${t180s_mkinitrdBak="${g10s_bakPath}/t180s_mkinitrd.bak"}
t180s_mkinitrdBeforeRemove=${t180s_mkinitrdBeforeRemove="${g10s_bakPath}/t180s_mkinitrd.beforeRemove"}

readonly t180s_flagBegin1="###UltraPath-t180s-1 begin,don't change this!###"
readonly t180s_flagEnd1="###UltraPath-t180s-1 end,don't change this!###"
readonly t180s_flagBegin2="###UltraPath-t180s-2 begin,don't change this!###"
readonly t180s_flagEnd2="###UltraPath-t180s-2 end,don't change this!###"
readonly t180s_flagBegin3="###UltraPath-t180s-3 begin,don't change this!###"
readonly t180s_flagEnd3="###UltraPath-t180s-3 end,don't change this!###"
readonly t180s_flagBegin4="###UltraPath-t180s-4 begin,don't change this!###"
readonly t180s_flagEnd4="###UltraPath-t180s-4 end,don't change this!###"
readonly t180s_flagBegin5="###UltraPath-t180s-5 begin,don't change this!###"
readonly t180s_flagEnd5="###UltraPath-t180s-5 end,don't change this!###"
readonly t180s_flagBegin6="###UltraPath-t180s-6 begin,don't change this!###"
readonly t180s_flagEnd6="###UltraPath-t180s-6 end,don't change this!###"

readonly t180s_kernelFile="/etc/sysconfig/kernel"
readonly t180s_kernelFileTmp=${t180s_kernelFileTmp="${g10s_tmpPath}/t180s_kernel.tmp"}
readonly t180s_kernelFileBak=${t180s_kernelFileBak="${g10s_bakPath}/t180s_kernel.bak"}
readonly t180s_kernelFileBeforeRemove=${t180s_kernelFileBeforeRemove="${g10s_bakPath}/t180s_kernel.beforeRemove"}
readonly t180s_flagBeginKernel="###UltraPath-t180s-kernel begin,don't change this!###"
readonly t180s_flagEndKernel="###UltraPath-t180s-kernel end,don't change this!###"



function t180s_useage()
{
    local allTypes
    allTypes=${t180s_allTypes//,/|}
    allTypes=${allTypes#|}
    allTypes=${allTypes%|}
    echo "$0 [OPTIONS]
    action=append|remove|repair
    type=${allTypes}"
    exit 1
}

function t180s_modiflyKernel()
{
    local ret
    g10s_checkExist -f "${t180s_kernelFile}" 2
    ret=`cat "${t180s_kernelFile}" 2>/dev/null|grep -E -c "(${t180s_flagBeginKernel}|${t180s_flagEndKernel})"`
    if [ ${ret} -ne 0 ]
    then
        print_warning "1001" "UltraPath code has been exist.[${t180s_kernelFile}]"
        return 1
    fi

    g10s_cp "${t180s_kernelFile}" "${t180s_kernelFileTmp}"
    if [ `tail -n 1 "${t180s_kernelFileTmp}"|grep -c "^[[:blank:]]*$"` -eq 0 ]
    then

        echo "" >> "${t180s_kernelFileTmp}"
    fi

	g60s_getHBAmoduleName
	    if [ `echo ${MODULE_LIST} | grep "mptsas" -c` -gt 0 ]
	    then
	        MODULE_LIST="${MODULE_LIST//"mptsas"/}"
	        MODULE_LIST_TMP="mptsas "
	        MODULE_LIST="$MODULE_LIST_TMP$MODULE_LIST"
	    fi
	t180s_findedHBAmodule=$MODULE_LIST

    echo "${t180s_flagBeginKernel}
if [ \`echo \"\${initrd_image}\" | grep -E -c \"(/nxup|/ultrapath)\"\` -ne 0 ]
then
    INITRD_MODULES=\"\${INITRD_MODULES} ${t180s_findedHBAmodule}\"
    INITRD_MODULES=\" \${INITRD_MODULES} \"
    INITRD_MODULES=\"\${INITRD_MODULES// nxupext_a / }\"
    INITRD_MODULES=\"\${INITRD_MODULES// nxup / }\"
    INITRD_MODULES=\"\${INITRD_MODULES// scsi_mod / }\"
    INITRD_MODULES=\"\${INITRD_MODULES// sd_mod / }\"
    INITRD_MODULES=\"\${INITRD_MODULES// sg / }\"
    INITRD_MODULES=\"scsi_mod sd_mod sg nxup nxupext_a \${INITRD_MODULES}\"
    INITRD_MODULES=\$(echo \${INITRD_MODULES})
    echo \"UltraPath--[INITRD_MODULES=\${INITRD_MODULES}]\"
fi
${t180s_flagEndKernel}" >> "${t180s_kernelFileTmp}"
    if [ $? -ne 0 ]
    then
        print_error "1002" "append UltraPath code failed.[${t180s_kernelFile}]"
        exit 1
    fi
    g10s_cp "${t180s_kernelFile}" "${t180s_kernelFileBak}"
    g10s_cp "${t180s_kernelFileTmp}" "${t180s_kernelFile}"
    rm -f "${t180s_kernelFileTmp}"
    return 0
}

function t180s_removeKernel()
{
    local ret
    local ret2
    ret=`cat "${t180s_kernelFile}" 2>/dev/null|grep -E -c "(${t180s_flagBeginKernel}|${t180s_flagEndKernel})"`
    if [ ${ret} -eq 2 ]
    then
        g10s_cp "${t180s_kernelFile}" "${t180s_kernelFileTmp}"
        sed -i "/${t180s_flagBeginKernel}/,/${t180s_flagEndKernel}/d" "${t180s_kernelFileTmp}"
        ret2=`cat "${t180s_kernelFileTmp}" 2>/dev/null|grep -E -c "(${t180s_flagBeginKernel}|${t180s_flagEndKernel})"`
        if [ ${ret2} -eq 0 ]
        then

            g10s_cp "${t180s_kernelFile}" "${t180s_kernelFileBeforeRemove}"
            g10s_cp "${t180s_kernelFileTmp}" "${t180s_kernelFile}"
            rm -f "${t180s_kernelFileTmp}"
        else
            print_error "1003" "remove UltraPath code failed.[${t180s_kernelFile}]"
            exit 1
        fi
    elif [ ${ret} -eq 1 ]
    then
        print_error "1004" "the file has half-baked UltraPath flags.[${t180s_kernelFile}]"
        exit 1
    elif [ ${ret} -eq 0 ]
    then
        print_debug "UltraPath code has been removed from ${t180s_kernelFile}"
    else
        print_error "1005" "the UltraPath flag is incorrect.[${t180s_kernelFile}]"
        exit 1
    fi
    return 0
}


function t180s_createSetupFile()
{
    g10s_checkExist -d "/lib/mkinitrd/setup/" 2
    if [ -f "${t180s_setupFile}" ] && [ `cat "${t180s_setupFile}"|grep -c "${t180s_UltraPathFlag}"` -eq 0 ]
    then
        print_error "1006" "the setup file is exist,but it's not build for UltraPath.[${t180s_setupFile}]"
        exit 1
    fi

    echo '#!/bin/bash' > "${t180s_setupFile}"
    echo "
${t180s_UltraPathFlag}
if [ \`echo \"\${initrd_image}\" | grep -E -c \"(/nxup|/ultrapath)\"\` -ne 0 ]
then
    mkdir -p \${tmp_mnt}/etc
    if [ ! -f \"/etc/up.conf\" ]
    then
        echo \"UltraPath--ERROR:not found /etc/up.conf\"
        exit 1
    fi
    cp -f \"/etc/up.conf\" \${tmp_mnt}/etc/
    echo \"UltraPath--copy /etc/up.conf to \${tmp_mnt}/etc/\"
    if [ ! -f \"/etc/up.hostinfo\" ]
    then
        echo \"UltraPath--ERROR:not found /etc/up.hostinfo\"
        exit 1
    fi
    cp -f \"/etc/up.hostinfo\" \${tmp_mnt}/etc/
    echo \"UltraPath--copy /etc/up.hostinfo to \${tmp_mnt}/etc/\"
fi
" >> "${t180s_setupFile}"
    g10s_chmodExec 700 "${t180s_setupFile}"
    return 0
}

function t180s_appendForSUSE11()
{
    t180s_createSetupFile
    t180s_modiflyKernel
    return 0
}

function t180s_removeForSUSE11()
{
    if [ -f "${t180s_setupFile}" ] && [ `cat "${t180s_setupFile}"|grep -c "${t180s_UltraPathFlag}"` -ne 0 ]
    then
        rm -f "${t180s_setupFile}"
    fi
    t180s_removeKernel
    return 0
}

function t180s_repairForSUSE11()
{
    local ret
    if [ ! -f "${t180s_setupFile}" ]
    then
        t180s_createSetupFile
    fi
    ret=`cat "${t180s_kernelFile}" 2>/dev/null|grep -E -c "(${t180s_flagBeginKernel}|${t180s_flagEndKernel})"`
    if [ ${ret} -ne 2 ]
    then
        t180s_modiflyKernel
    fi
    return 0
}

function t180s_removeForSUSE10()
{
    local ret
    t180s_removeKernel

    print_debug "begin removing UltraPath code[${t180s_mkinitrdFile}]"
    g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdTmp}"
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2})")
    if [ ${ret} -ne 2 ]
    then
        print_debug "skip removing UltraPath code 2..."
    else
        sed -i "/${t180s_flagBegin2}/,/${t180s_flagEnd2}/d" "${t180s_mkinitrdTmp}"
    fi
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin3}|${t180s_flagEnd3})")
    if [ $ret -ne 2 ]
    then
        print_debug "skip removing UltraPath code 3..."
    else
        sed -i "/${t180s_flagBegin3}/,/${t180s_flagEnd3}/d" "${t180s_mkinitrdTmp}"
    fi
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin4}|${t180s_flagEnd4})")
    if [ $ret -ne 2 ]
    then
        print_debug "skip removing UltraPath code 4..."
    else
        sed -i "/${t180s_flagBegin4}/,/${t180s_flagEnd4}/d" "${t180s_mkinitrdTmp}"
    fi
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin5}|${t180s_flagEnd5})")
    if [ $ret -ne 2 ]
    then
        print_debug "skip removing UltraPath code 5..."
    else
        sed -i "/${t180s_flagBegin5}/,/${t180s_flagEnd5}/d" "${t180s_mkinitrdTmp}"
    fi


    ret=$(cat ${t180s_mkinitrdTmp}|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2}|${t180s_flagEnd2}|${t180s_flagBegin3}|${t180s_flagEnd3}|${t180s_flagBegin4}|${t180s_flagEnd4}|${t180s_flagBegin5}|${t180s_flagEnd5})")
    if [ ${ret} -ne 0 ]
    then
        print_error "1012" "check failed after removing UltraPath code[${t180s_mkinitrdTmp}]"
        exit 1
    else
        print_debug "backup file [${t180s_mkinitrdTmp} to ${t180s_mkinitrdBeforeRemove}]"
        g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdBeforeRemove}"
        g10s_cp "${t180s_mkinitrdTmp}" "${t180s_mkinitrdFile}"
        rm -rf "${t180s_mkinitrdTmp}"
        print_debug "remove UltraPath code successfully[${t180s_mkinitrdFile}]"
    fi
    return 0
}

function t180s_repairForSUSE10()
{
    local ret
    local ret2

    ret=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2}|${t180s_flagBegin3}|${t180s_flagEnd3}|${t180s_flagBegin4}|${t180s_flagEnd4}|${t180s_flagBegin5}|${t180s_flagEnd5})")

    if [ ${ret} -ne 0 ] && [ ${ret} -ne 8 ]
    then
        print_debug "remove UltraPath code from file[${t180s_mkinitrdFile}]"
        t180s_removeForSUSE10
    fi

    ret2=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2}|${t180s_flagBegin3}|${t180s_flagEnd3}|${t180s_flagBegin4}|${t180s_flagEnd4}|${t180s_flagBegin5}|${t180s_flagEnd5})")
    if [ ${ret2} -eq 0 ]
    then
        print_debug "append UltraPath code to file[${t180s_mkinitrdFile}]"

        t180s_appendForSUSE10
    fi
    return 0
}

function t180s_appendForSUSE10()
{
    local ret

    ret=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2}|${t180s_flagBegin3}|${t180s_flagEnd3}|${t180s_flagBegin4}|${t180s_flagEnd4})")
    print_debug "before append code to ${t180s_mkinitrdFile},ret=${ret}"
    if [ ${ret} -ne 0 ]
    then
        print_warning "1007" "UltraPath code has been exist in file[${t180s_mkinitrdFile}]"
        return 0
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*echo -n > \$tmp_mnt/etc/mtab[[:blank:]]*$')
    if [ ${ret} -ne 1 ]
    then
        print_error "1008" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*rm -f \$root_dir/\$boot_dir/initrd[[:blank:]]*$')
    if [ ${ret} -ne 1 ]
    then
        print_error "1009" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*ln -s "\${initrd_image#\$boot_dir/}" \$root_dir/\$boot_dir/initrd[[:blank:]]*$')
    if [ ${ret} -ne 1 ]
    then
        print_error "1010" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*mkinitrd_kernel \$kernel_image \$initrd_image[[:blank:]]*$')
    if [ ${ret} -ne 1 ]
    then
        print_error "1010" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi

    g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdTmp}"


	g60s_getHBAmoduleName
	if [ `echo ${MODULE_LIST} | grep "mptsas" -c` -gt 0 ]
	then
	     MODULE_LIST="${MODULE_LIST//"mptsas"/}"
	     MODULE_LIST_TMP="mptsas "
	     MODULE_LIST="$MODULE_LIST_TMP$MODULE_LIST"
	fi
	t180s_findedHBAmodule=$MODULE_LIST
	t180s_findedHBAmodule=`echo ${t180s_findedHBAmodule}`


sed -i "/^[[:blank:]]*mkinitrd_kernel \$kernel_image \$initrd_image[[:blank:]]*$/i \
${t180s_flagBegin5}\\
if [ \`echo \"\${initrd_image}\" | grep -E -c \"\(/nxup\|/ultrapath\)\"\` -ne 0 ] \\
then\\
    if [ \"${t180s_findedHBAmodule}\" != \"\" ] \\
    then\\
        for hbaModule in ${t180s_findedHBAmodule} \\
        do \\
             modules=\"\${modules//\${hbaModule}/}\" \\
        done \\
    fi\\
    modules=\"\${modules} scsi_mod sd_mod sg nxup nxupext_a ${t180s_findedHBAmodule}\" \\
fi\\
${t180s_flagEnd5}
/^[[:blank:]]*echo -n > \$tmp_mnt\/etc\/mtab[[:blank:]]*$/a \
${t180s_flagBegin2}\\
if [ \`echo \"\${initrd_image}\" | grep -E -c \"\(/nxup\|/ultrapath\)\"\` -ne 0 ] \\
then\\
    if [ ! -f \"\/etc\/up.conf\" ]\\
    then\\
        echo \"UltraPath--ERROR:not found \/etc\/up.conf\"\\
        exit 1\\
    fi\\
    echo \"UltraPath--copy \/etc\/up.conf to \${tmp_mnt}\/etc\/\"\\
    cp -f \"\/etc\/up.conf\" \"\${tmp_mnt}\/etc\/up.conf\"\\
    if [ ! -f \"\/etc\/up.hostinfo\" ]\\
    then\\
        echo \"UltraPath--ERROR:not found \/etc\/up.hostinfo\"\\
        exit 1\\
    fi\\
    echo \"UltraPath--copy \/etc\/up.hostinfo to \${tmp_mnt}\/etc\/\"\\
    cp -f \"\/etc\/up.hostinfo\" \"\${tmp_mnt}\/etc\/up.hostinfo\"\\
fi\\
${t180s_flagEnd2}
/^[[:blank:]]*rm -f \$root_dir\/\$boot_dir\/initrd[[:blank:]]*$/i \
${t180s_flagBegin3}\\
if [ \`echo \"\${initrd_image}\" | grep -E -c \"\(/nxup\|/ultrapath\)\"\` -ne 0 ]\\
then\\
    echo \"UltraPath--the image has UltraPath...\"\\
    if [ \"\${initrd_image#\$boot_dir\/initrd-}\" = \"\${kernel_image#\$boot_dir\/vmlinu[xz]-}\" ] \\
    then\\
        echo \"UltraPath--reset initrd...\"\\
        rm -f \$root_dir\/\$boot_dir\/initrd\\
        ln -s \"\${initrd_image#\$boot_dir\/}\" \$root_dir\/\$boot_dir\/initrd\\
    fi\\
else\\
${t180s_flagEnd3}
/^[[:blank:]]*ln -s \"\${initrd_image#\$boot_dir\/}\" \$root_dir\/\$boot_dir\/initrd[[:blank:]]*$/a \
${t180s_flagBegin4}\\
fi\\
${t180s_flagEnd4}" "${t180s_mkinitrdTmp}"

    ret=$(cat "${t180s_mkinitrdTmp}"|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2}|${t180s_flagBegin3}|${t180s_flagEnd3}|${t180s_flagBegin4}|${t180s_flagEnd4})")
    if [ ${ret} -eq 6 ]
    then
        g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdBak}"
        g10s_cp "${t180s_mkinitrdTmp}" "${t180s_mkinitrdFile}"
        rm -f "${t180s_mkinitrdTmp}"
    else
        print_error "1011" "modify mkinitrd failed.[${t180s_mkinitrdFile}]"
        exit 1
    fi
    return 0
}

function t180s_getModprobeConfName()
{
    g10s_getOSType

    if [ -f /sbin/dracut ] || [ "${g10s_OSVersion}" = "ROCKY_2.6.32.41" ] || [ "${g10s_OSVersion}" = "ROCKY6SP4" ] || [ "${g10s_OSVersion}" = "ROCKY4SP2" ] || [ "${g10s_OSVersion}" = "ROCKY6SP6" ]
    then
        t180s_modprobeConfName="/etc/modprobe.d/nxupmodules.conf"
        [ ! -f "${t180s_modprobeConfName}" ] && touch "${t180s_modprobeConfName}"
        g10s_chmodExec 600 "${t180s_modprobeConfName}"
    elif [ -f /etc/modprobe.conf.local ]
    then
        t180s_modprobeConfName="/etc/modprobe.conf.local"
    elif [ -f /etc/modprobe.conf ]
    then
        t180s_modprobeConfName="/etc/modprobe.conf"
    else
        print_warning "1002" "not found modprobe config."
        return 1
    fi
    return 0
}

function t180s_appendHBAmoduleForREDHAT5()
{
    local tmpHBAmodule=""
    local baseIndex=90
    local isExist="1"

    t180s_getModprobeConfName

    g60s_getHBAmoduleName
    if [ `echo ${MODULE_LIST} | grep "mptsas" -c` -gt 0 ]
    then
	MODULE_LIST="${MODULE_LIST//"mptsas"/}"
	MODULE_LIST_TMP="mptsas "
	MODULE_LIST="$MODULE_LIST_TMP$MODULE_LIST"
    fi
    t180s_findedHBAmodule=$MODULE_LIST
    t180s_findedHBAmodule=`echo ${t180s_findedHBAmodule}`

    for tmpHBAmodule in `echo ${t180s_findedHBAmodule}`
    do

        if [ `cat ${t180s_modprobeConfName} 2>/dev/null| grep -c "^[[:blank:]]*alias.*${tmpHBAmodule}"` -eq 0 ]
        then
            isExist="0"
        fi
    done

    if [ "${isExist}" = "1" ]
    then
        return 0
    fi

    echo "${t180s_flagBegin6}" >>  ${t180s_modprobeConfName}
    for tmpHBAmodule in `echo ${t180s_findedHBAmodule}`
    do
        if [ `cat ${t180s_modprobeConfName} 2>/dev/null| grep -c "^[[:blank:]]*alias.*${tmpHBAmodule}"` -ne 0 ]
        then
            continue
        fi
        print_debug "append ${tmpHBAmodule} modconfig code[${t180s_modprobeConfName}]"
        echo "alias scsi_hostadapter${baseIndex} ${tmpHBAmodule}" >>  ${t180s_modprobeConfName}

        let "baseIndex=baseIndex+1"
    done
    echo "${t180s_flagEnd6}" >>  ${t180s_modprobeConfName}

    return 0
}

function t180s_removeHBAmoduleForREDHAT5()
{
    local ret

    t180s_getModprobeConfName

    ret=$(cat ${t180s_modprobeConfName} 2>/dev/null|grep -E -c "(${t180s_flagBegin6}|${t180s_flagEnd6})")
    if [ ${ret} -ne 2 ]
    then
        print_debug "skip removing UltraPath code 2..."
    else
        sed -i "/${t180s_flagBegin6}/,/${t180s_flagEnd6}/d" "${t180s_modprobeConfName}"
    fi

    return 0

}

function t180s_appendForREDHAT5()
{
    local ret
    local load_modules
    local module_names

    t180s_appendHBAmoduleForREDHAT5


    ret=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2}|${t180s_flagEnd2})")
    print_debug "before append code to ${t180s_mkinitrdFile},ret=${ret}"
    if [ ${ret} -ne 0 ]
    then
        print_warning "1013" "UltraPath code has been exist in file[${t180s_mkinitrdFile}]"
        return 0
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*target[[:blank:]]*=[[:blank:]]*\$1' )
    if [ ${ret} -ne 1 ]
    then
        print_error "1014" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi
    ret=$(cat "${t180s_mkinitrdFile}" 2>/dev/null|grep -E -c '^[[:blank:]]*mkdir[[:blank:]]*-p[[:blank:]]*\$MNTIMAGE/etc[[:blank:]]*$')
    if [ ${ret} -ne 1 ]
    then
        print_error "1015" "not found the key words in file[${t180s_mkinitrdFile}]"
        exit 1
    fi

    g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdTmp}"

    load_modules="PREMODS"
    if [ `modprobe -l scsi_mod | wc -l` -ne 0 ]
    then
	load_modules="PRESCSIMODS"
    fi
    module_names="nxup nxupext_a"
    if [ `modprobe -l sg | wc -l` -ne 0 ]
    then
	module_names="sg nxup nxupext_a"
    fi

    sed -i "/^[[:blank:]]*target[[:blank:]]*=[[:blank:]]*\$1/a \
${t180s_flagBegin1} \\
if [ \`echo \"\${target}\" | grep -E -c \"\(/nxup\|/ultrapath\)\"\` -ne 0 ] \\
then \\
    if [ \`modprobe -l sd_mod | wc -l\` -ne 0 ] && [ \`echo \${${load_modules}} | grep \"sd_mod\" -c\` -eq 0 ] \\
    then \\
    ${load_modules}=\"\${${load_modules}} sd_mod ${module_names}\" \\
    else \\
    ${load_modules}=\"\${${load_modules}} ${module_names}\" \\
    fi \\
fi \\
${t180s_flagEnd1}
/^[[:blank:]]*mkdir[[:blank:]]*-p[[:blank:]]*\$MNTIMAGE\/etc[[:blank:]]*$/a \
${t180s_flagBegin2} \\
if [ \`echo \"\${target}\" | grep -E -c \"\(/nxup\|/ultrapath\)\"\` -ne 0 ] \\
then \\
    if [ ! -f \"\/etc\/up.conf\" ]\\
    then\\
        echo \"UltraPath--ERROR:not found \/etc\/up.conf\"\\
        exit 1\\
    fi\\
    cp -f \"\/etc\/up.conf\" \"\${MNTIMAGE}\/etc\/up.conf\"\\
    if [ ! -f \"\/etc\/up.hostinfo\" ]\\
    then\\
        echo \"UltraPath--ERROR:not found \/etc\/up.hostinfo\"\\
        exit 1\\
    fi\\
    cp -f \"\/etc\/up.hostinfo\" \"\${MNTIMAGE}\/etc\/up.hostinfo\"\\
fi \\
${t180s_flagEnd2}" "${t180s_mkinitrdTmp}"


    ret=$(cat "${t180s_mkinitrdTmp}"|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2}|${t180s_flagEnd2})")
    if [ ${ret} -eq 4 ]
    then
        g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdBak}"
        g10s_cp "${t180s_mkinitrdTmp}" "${t180s_mkinitrdFile}"
        rm -f "${t180s_mkinitrdTmp}"
    else
        print_error "1016" "modify mkinitrd failed.[${t180s_mkinitrdFile}]"
        exit 1
    fi
    return 0
}

function t180s_removeForREDHAT5()
{
    local ret

    t180s_removeHBAmoduleForREDHAT5

    print_debug "begin removing UltraPath code[${t180s_mkinitrdFile}]"
    g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdTmp}"
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1})")
    if [ ${ret} -ne 2 ]
    then
        print_debug "skip removing UltraPath code 1..."
    else
        sed -i "/${t180s_flagBegin1}/,/${t180s_flagEnd1}/d" "${t180s_mkinitrdTmp}"
    fi
    ret=$(cat ${t180s_mkinitrdTmp} 2>/dev/null|grep -E -c "(${t180s_flagBegin2}|${t180s_flagEnd2})")
    if [ ${ret} -ne 2 ]
    then
        print_debug "skip removing UltraPath code 2..."
    else
        sed -i "/${t180s_flagBegin2}/,/${t180s_flagEnd2}/d" "${t180s_mkinitrdTmp}"
    fi


    ret=$(cat ${t180s_mkinitrdTmp}|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2}|${t180s_flagEnd2})")
    if [ ${ret} -ne 0 ]
    then
        print_error "1017" "check failed after removing UltraPath code[${t180s_mkinitrdTmp}]"
        exit 1
    else
        print_debug "backup file [${t180s_mkinitrdTmp} to ${t180s_mkinitrdBeforeRemove}]"
        g10s_cp "${t180s_mkinitrdFile}" "${t180s_mkinitrdBeforeRemove}"
        g10s_cp "${t180s_mkinitrdTmp}" "${t180s_mkinitrdFile}"
        rm -rf "${t180s_mkinitrdTmp}"
        print_event "1018" "remove UltraPath code successfully.[${t180s_mkinitrdFile}]"
    fi
    return 0
}

function t180s_repairForREDHAT5()
{
    local ret


    ret=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2})")

    if [ ${ret} -ne 0 ] && [ ${ret} -ne 4 ]
    then
        print_debug "remove UltraPath code from file[${t180s_mkinitrdFile}]"
        t180s_removeForREDHAT5
    fi

    ret2=$(cat "${t180s_mkinitrdFile}"|grep -E -c "(${t180s_flagBegin1}|${t180s_flagEnd1}|${t180s_flagBegin2}|${t180s_flagEnd2})")
    if [ ${ret2} -eq 0 ]
    then
        print_debug "append UltraPath code to file[${t180s_mkinitrdFile}]"

        t180s_appendForREDHAT5
    fi
    return 0
}



function t180s_append()
{
    g10s_eval "t180s_appendFor${t180s_type}"
    print_event "1019" "The UltraPath start items are added successfully."
    return 0
}
function t180s_remove()
{
    g10s_eval "t180s_removeFor${t180s_type}"
    print_event "1020" "remove UltraPath code successfully."
    return 0
}
function t180s_repair()
{
    g10s_eval "t180s_repairFor${t180s_type}"
    return 0
}


g10s_checkExist -f "${t180s_mkinitrdFile}" 2

while [ $# -gt 0 ]
do
    t180s_param="$1"
    t180s_param1=${t180s_param%%=*}
    t180s_param2=${t180s_param##*=}
    print_debug "t180s_param=${t180s_param},t180s_param1=${t180s_param1},t180s_param2=${t180s_param2}"
    case "${t180s_param1}" in
        "action")
            t180s_action="${t180s_param2}"
            ;;
        "type")
            t180s_type="${t180s_param2}"
            ;;
        *)
            print_error "1021" "unknown parameter[${t180s_param}]"
            t180s_useage
            ;;
    esac
    shift
done

if [ "${t180s_type}" = "" ] || [ `echo "${t180s_allTypes}"|grep -c ",${t180s_type},"` -eq 0 ]
then
    print_error "1022" "please set correct parameter[type=XXX]"
    t180s_useage
fi

if [ "${t180s_action}" = "append" ]
then
    t180s_append
elif [ "${t180s_action}" = "remove" ]
then
    t180s_remove
elif [ "${t180s_action}" = "repair" ]
then
    t180s_repair
else
    print_error "1023" "unknown parameter[action=${t180s_action}]"
    t180s_useage
fi

