#!/bin/bash

t220s_toolsDir="../toolLib"
g20s_LIBFILE=${g20s_LIBFILE="../globalLib/g20s_install"}
g30s_LIBFILE=${g30s_LIBFILE="../globalLib/g30s_systemEnvironment"}

if [ -f "${g20s_LIBFILE}" ] && [ -f "${g30s_LIBFILE}" ]
then
	. "${g20s_LIBFILE}"

	. "${g30s_LIBFILE}"

elif [ -f "/UltraPath/install/linuxTools/globalLib/g20s_install" ] \
    && [ -f "/UltraPath/install/linuxTools/globalLib/g30s_systemEnvironment" ]
then
    pwdPath=`pwd`
    t220s_toolsDir="/UltraPath/install/linuxTools/toolLib"
    cd "${t220s_toolsDir}"

    . ../globalLib/g20s_install

    . ../globalLib/g30s_systemEnvironment

    cd ${pwdPath}
    unset pwdPath
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib file.\033[0m"
	exit 1
fi

t220s_hasWarning="0"

function t220s_checkUltraPathModule()
{
    if [ `lsmod|awk '{print $1}'|grep -c "^[[:blank:]]*nxup[[:blank:]]*$"` -eq 0 ]
    then
        print_warning "1001" "nxup module doesn't insmod."
        t220s_hasWarning="1"
        return 1
    else
        print_event "1002" "nxup module has been loaded."
    fi


    if [ `ps x|grep "upservice" | grep -v "grep"|wc -l` -lt 1 ]
    then
        print_warning "1003" "upservice is not running."
        t220s_hasWarning="1"
        return 1
    else
        print_event "1004" "upservice is running."
    fi
    return 0
}


function t200s_checkEnvironment()
{
    local ret

    bash t240s_checkIscsi.sh action=after
    ret=$?
    if [ ${ret} -ne 0 ]
    then
        t220s_hasWarning="1"
    fi

    bash t250s_checkFC.sh action=after
    ret=$?
    if [ ${ret} -ne 0 ]
    then
        t220s_hasWarning="1"
    fi

    return 0
}

t220s_checkUltraPathModule

t200s_checkEnvironment

if [ "${t220s_hasWarning}" = "1" ]
then
    print_event "1006" "There's some warning,please dispose it."
    exit 1
else
    print_event "1007" "checking compelete."
fi












