g10s_LIBFILE=${g10s_LIBFILE="/UltraPath/install/linuxTools/globalLib/g10s_pub"}
if [ -f "${g10s_LIBFILE}" ]
then
	. "${g10s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g10s_LIBFILE}]\033[0m"
	exit 1
fi

mppLnx_isIscsiDriverInstalled_fn()
{

   if [ -f /sbin/iscsid ]
   then
      echo "1"
   else
      echo "0"
   fi
}

checkHBAConfig ()
{
   ISCSI_SOFT_INITIATOR=$(mppLnx_isIscsiDriverInstalled_fn)

   if [ -f /usr/sbin/lspci ] 
   then 
       TEMP_PATH="/usr/sbin"
   elif  [ -f /usr/bin/lspci ]
   then
       TEMP_PATH="/usr/bin"
   else
       TEMP_PATH="/sbin"
   fi
   
   if [ -f /bin/gawk ]
   then 
       awk_tool="/bin/gawk"
   else
       awk_tool="awk"
   fi

   lspci_n=`lspci -n | ${awk_tool} '{print $2}'` #DVS
   lspci_numeric=`expr "$lspci_n" : 'Class'`

   if [ "$lspci_numeric" == "0" ]
   then
        HBAModels=`$TEMP_PATH/lspci -n | ${awk_tool} '/ 0c04:/ || / 0c06:/ || / 0100.*1077.*22../ || / 0100.*1000.*005/ ||/ 0280:/  {print $2 $3 $4 $5 }'`
   else
        HBAModels=`$TEMP_PATH/lspci -n | ${awk_tool} '/Class 0c04/ || /Class 0c06/ || /Class 0100.*1077.*22../ || /Class 0100.*1000.*005/ ||/Class 0280/  {print $3 $4 $5 $6 }'` #DVS
   fi

   echo "$HBAModels" | ${awk_tool} -v ISCSI_SOFT_INITIATOR=${ISCSI_SOFT_INITIATOR}\
        'BEGIN {
                NumberOfSupportedHBAModel = 0;
                nonSupportedHBAVendorExists = 0;
                FS=":";

                SupportedHBAModel["1000"] = "0050,0054,0056,0058,005a,005e,0062,0064,0072,0621,0622,0624,0626,0628,0640,0642,0646";
                SupportedHBAModel["1077"] = "2300,2310,2312,2322,2340,2342,2420,2422,2432,2440,2442,2460,2462,2532,4010,4022,4032,5422,5432,6312,6322,8001,8432,7322";
                SupportedHBAModel["10df"] = "f011,f015,f095,f098,f0a1,f0a5,f0d5,f0e1,f0e5,f900,f980,fa00,fa01,fc00,fc10,fc20,fc40,fd00,fd11,fd12,fe00,fe05,fe11,fe12,f100,f111,f112,e628,e620,e630";
		SupportedHBAModel["1657"] = "0013,0017,0014";

                SupportedHBAModel["15b3"] = "5a44,6274,6278,6282,634a,673c,1003";

                errorMessage[1] = "Unsupported Host Adapter Vendor: Vendor ID";
                errorMessage[2] = "Unsupported Host Adapter Model: Product ID";

        }
        {
                HBAVendorSupported = 0;
                HBAModelSupported = 0;
                HBAVendor = $2;
                HBAModel = $3;

        if ( match($0,"Class 0100") != 0  && match(HBAVendor, "1077") != 0  && match(HBAModel,"22") != 0 )

        {

        }
        else
        {
                    for (i in SupportedHBAModel)
                    {
                            if ( match(HBAVendor,i) != 0)
                            {
                                    HBAVendorSupported = 1;
                                     SupportedVendor[i] ++;

                                    split(SupportedHBAModel[i],a,",");
                                    for ( j in a )
                                    {
                                            if (match(HBAModel,a[j]) != 0)
                                            {
                                                    HBAModelSupported = 1;
                                                    break;
                                            }
                                    }
                                    if ( HBAModelSupported == 0)
                                    {
                                            UnsupportedModelFromVendor[i] = 1;
                                    }
                    break;
                            }
                    }
                    if (HBAVendorSupported == 0)
                    {
                         nonSupportedHBAVendorExists = 1;
                    }
        }
        }
        END {

        configCheckResult = 0;

        for (i in SupportedVendor) {
            if (match (i, "1077") != 0)
                VendorName = "QLogic" ;
            if (match (i, "1000") != 0)
                VendorName = "LSI";
            if (match (i, "10df") != 0)
                VendorName = "Emulex";
            if (match (i, "15b3") != 0)
                VendorName = "Supported";

            if (match (i, "1657") != 0)
                VendorName = "Brocade";
                        SupportedVendors++;
                        echo $SupportedVendors
        }
        echo $SupportedVendors
        if ( SupportedVendors > 1 )
        {
           print "Host Adapters from different supported vendors co-exists on your system.";
           exit 2
        }

        } ' ;
        if [ $? -eq 2 ]
        then
            return 1
        fi
        return 0
}

function g30s_checkMultiChannel()
{
   local iCount=0
   g30s_initiatorType=","

   [ `lspci|grep -c "Fibre"` -ne 0 ] && g30s_initiatorType="${g30s_initiatorType}FC,"

   if [ `iscsiadm -m node 2>/dev/null|wc -l` -ne 0 ]
   then
        g30s_initiatorType="${g30s_initiatorType}ISCSI,"
   fi

   iCount=`echo "${g30s_initiatorType}"|awk -F "," '{print NF}'`
   if [ ${iCount} -ge 4 ]
   then
        print_warning "1001" "both found iscsi nodes and Fibre Channel,You can only use one of them." "g30s"
        return 1
   fi
   return 0
}

function t224_checkEnvironment()
{
    local tmpRet
    tmpRet=0
    pwdPath=`pwd`
    cd /UltraPath/install/linuxTools/toolLib
    bash t240s_checkIscsi.sh action=after
    if [ $? -eq 0 ]
    then
       tmpRet=0
    fi
    bash t250s_checkFC.sh action=after
    if [ $? -eq 0 ]
    then
        if [ $tmpRet -eq 0 ]
        then
            checkHBAConfig
            if [ $? -eq 1 ]
            then
                return 1 
            fi
            cd "${pwdPath}"
            return 0
        fi
    fi
    checkHBAConfig
    cd "${pwdPath}"
    return 1
}
t224_checkEnvironment
