#!/bin/bash

export g10s_isQuiet="1"

g20s_LIBFILE=${g20s_LIBFILE="../globalLib/g20s_install"}
if [ -f "${g20s_LIBFILE}" ]
then
	. "${g20s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g20s_LIBFILE}]\033[0m"
	exit 1
fi

t70s_installSolution="${g10s_bakPath}/t70s_install.solution"
t70s_installSolutionbak="/UltraPath/install/t70s_install.solution.bak"


function t70s_createSolution()
{
    local solutionType
    local ret
    solutionType="service"

    ret=`cat ${g10s_ultraPathPackagesInfo} | grep -c "t140s_solutionType"`
    if [ ${ret} -ne 0 ]
    then
        g10s_getConf "${g10s_ultraPathPackagesInfo}" "t140s_solutionType"
        if [ "${g10s_confValue}" != "" ]
        then
            solutionType="${g10s_confValue}"
        fi
    fi


    bash t140s_createSolution.sh "${t70s_installSolution}" "${solutionType}"
    if [ $? -ne 0 ]
    then
        print_error "1004" "create solution failed."
        exit 1
    fi
    
    if [ -f "${t70s_installSolution}" ]
    then
        cp -f "${t70s_installSolution}" "${t70s_installSolutionbak}" 2>/dev/null
        print_debug "backup ${t70s_installSolution} successfully in [${t70s_installSolutionbak}]"
    fi    
    return 0
}

function t70s_debpostinst()
{

    export t120s_backList="${g10s_bakPath}/t70s_action.lst.install"

    if [ ! -f "${t120s_backList}" ] || [ `cat "${t120s_backList}"|grep -c "^###end backup###t70s_beforeInstall###"` -eq 0 ]
    then
        bash t120s_bakUpFile.sh "t70s_beforeInstall"
    fi
    unset t120s_backList

    g10s_saveConf "${g10s_ultraPathPackagesInfo}" "f20_solution" "createSolution"
    t70s_createSolution

    g10s_debugPoint "afterCreateSolution"
    g20s_installBySolution "${t70s_installSolution}"
    print_debug "execute solution successfully[${t70s_installSolution}]"
    echo "##########first install####end#####`date +%Y%m%d%H%M%S`########">>"${g10s_ultraPathPackagesInfo}"
    return 0
}


g10s_rootCheck
g10s_curDirCheck
if [ "$1" = "debpostinst" ]
then
    t70s_debpostinst
elif [ "$1" = "rollback" ]
then
    print_event "1002" "begin rollback"
    bash t80s_prerm.sh "t70s_postinst"
else
    t70s_debpostinst
fi



