#!/bin/bash

export g10s_isQuiet="1"

g20s_LIBFILE=${g20s_LIBFILE="../globalLib/g20s_install"}
if [ -f "${g20s_LIBFILE}" ]
then
	. "${g20s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
	echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g20s_LIBFILE}]\033[0m"
	exit 1
fi
g20s_forceUninstall="1"

t80s_baseDir=`cd ${g10s_bakPath};cd ..;pwd`
if [ ! -d "${t80s_baseDir}" ]
then
    print_error "1001" "get base directory failed[${t80s_baseDir},bakPath:${g10s_bakPath}]"
    exit 1
fi
t80s_tarBakDir="${t80s_baseDir}/t80s_uninstallBak"
mkdir -p "${t80s_tarBakDir}"
t80s_bakDirName=${g10s_bakPath##*/}
if [ ! -d "${t80s_baseDir}/${t80s_bakDirName}" ] || [ `echo "${t80s_baseDir}/${t80s_bakDirName}" |grep -c "[[:blank:]]"` -ne 0 ]
then
    print_error "1002" "illegimate t80s_bakDirName[${t80s_bakDirName},baseDir:${t80s_baseDir}]"
    exit 1
fi


t80s_tarCount=${t80s_tarCount:=10}

t80s_skipBackUP=${t80s_skipBackUP:="0"}


t80s_ISRollBack="0"

function t80s_tarBackUP()
{
    local pwdPath
    local ret
    local filename
    local tarFileName

    pwdPath=`pwd`
    cd "${t80s_tarBakDir}"
    ret=`ls t80s_uninstall\.*\.tar 2>/dev/null|wc -l`
	if [ ${ret} -gt ${t80s_tarCount} ]
	then
		filename=`ls t80s_uninstall\.*\.tar|sort|head -n 1`
		print_debug "remove compress file[${filename}]"
		rm -f "${filename}"
	fi

    cd "${t80s_baseDir}"
    if [ ! -d "${t80s_bakDirName}" ]
    then
        print_warning "1003" "not found directory[${t80s_bakDirName}]"
        return 1
    fi
    print_debug "compress backup file..."
	sleep 3
	tarFileName="t80s_uninstall.`date +%Y%m%d%H%M%S`.tar"

    tar -cf "${tarFileName}" "${t80s_bakDirName}"
    if [ $? -ne 0 ]
    then
        print_warning "1004" "compress files failed."
        return 0
    else
        if [ "${t80s_ISRollBack}" = "1" ]
        then
            mv "${tarFileName}" "${t80s_tarBakDir}/t80s_uninstall.installFailed.`date +%Y%m%d%H%M%S`.tar"
        else
            mv "${tarFileName}" "${t80s_tarBakDir}"
        fi
        [ "${t80s_ISRollBack}" != "1" ] && rm -rf ${t80s_bakDirName}/*
        print_debug "compressed files successfully."
    fi
    return 0
}

function t80s_debprerm()
{
    if [ "${t80s_skipBackUP}" = "0" ]
    then

        export t120s_backList="${g10s_bakPath}/t80s_action.lst.uninstall"

        if [ ! -f "${t120s_backList}" ] || [ `cat "${t120s_backList}"|grep -c "^###end backup###t80s_beforeUninstall###"` -eq 0 ]
        then
            bash t120s_bakUpFile.sh "t80s_beforeUninstall"
        fi
        unset t120s_backList
    else
        print_event "1005" "skip backup data"
    fi

    
    g20s_uninstallBySolution
    t80s_tarBackUP

    return 0
}


g10s_rootCheck
g10s_curDirCheck
print_debug "\$1=${1}"
if [ "$1" = "debprerm" ]
then
    t80s_debprerm 
    rm -f "${g10s_ultraPathPackagesInfo}"
elif [ "$1" = "t70s_postinst" ]
then
    t80s_ISRollBack="1"
    t80s_debprerm 
elif [ "$1" = "rollback" ]
then

    print_debug "rollback..."
else
    t80s_debprerm 
    rm -f "${g10s_ultraPathPackagesInfo}"
fi
