#!/bin/bash



g20s_LIBFILE=${g20s_LIBFILE="../globalLib/g20s_install"}
if [ -f "${g20s_LIBFILE}" ]
then
    . "${g20s_LIBFILE}"
else
    fileFlag=${0##*/}
    fileFlag=${fileFlag%%_*}
    echo -e "\033[31m[ERROR:15][${fileFlag}][`date +%Y%m%d%H%M%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] not found the lib[${g20s_LIBFILE}]\033[0m"
    exit 1
fi



function t90s_useage()
{
    echo "USAGE:$0 [rollback|backup]"
    exit 1
}


function t91s_rollback()
{
    local OLD_IFS
    local iCount
    local tmpKernel
    local tmpModulePath
    local tmpUnamer
    local pr_key

    print_event "1001" "start the rollback files installation"

    g10s_checkExist -f "${g20s_modulesBaseDir}/../otherTools/${g10s_R3upadm}" 2
    g10s_checkExist -f "${g20s_modulesBaseDir}/../otherTools/${g10s_R5upadm}" 2
    set -e
    install -o root -g root -m 0500 -D "${g20s_modulesBaseDir}/../otherTools/${g10s_R5upadm}" /usr/sbin/${g10s_R5upadm}
    install -o root -g root -m 0500 -D "${g20s_modulesBaseDir}/../otherTools/${g10s_R3upadm}" /usr/sbin/${g10s_R3upadm}

    [ -f /usr/sbin/upTools ] && rm -rf /usr/sbin/upTools

    ln -s /usr/sbin/${g10s_R3upadm} /usr/sbin/upTools
    install -o root -g root -m 0500 -D "${g20s_modulesBaseDir}/../otherTools/slTools" /sbin/slTools
    set +e


    pwdPath=`pwd`
    set -e
    cd "${g20s_modulesBaseDir}/../"
    install -o root -g root -m 0600 -D "${g10s_onlinebackupDir}/up.conf" /etc/up.conf
    install -o root -g root -m 0600 -D "${g10s_onlinebackupDir}/user_cfg.xml" /etc/user_cfg.xml
    install -o root -g root -m 0500 -D linuxTools/toolLib/t190s_upLinux.sh /usr/sbin/upLinux
    install -o root -g root -m 0500 -D linuxTools/toolLib/t100s_upBusRescan.sh /sbin/upRescan

    [ -f /usr/sbin/hot_add ] && rm -rf /usr/sbin/hot_add
    ln -s /sbin/upRescan /usr/sbin/hot_add
    set +e
    cd "${pwdPath}"


    return 0
}

function t91s_backup()
{
    print_debug "backup files"
    g10s_cp  "${g10s_ultraPathPackagesInfo}" "${g10s_onlinebackupDir}"
    g10s_cp  /etc/user_cfg.xml  "${g10s_onlinebackupDir}"
    g10s_cp  /etc/up.conf  "${g10s_onlinebackupDir}"

    return 0
}

function t91s_removeconf()
{
    print_debug "remove conf files"
    [ -f /etc/user_cfg.xml ] && rm -rf /etc/user_cfg.xml
    [ -f /etc/up.conf ] && rm -rf /etc/up.conf

    return 0
}

function t91s_copyconf()
{
    print_debug "copy conf files"
    install -o root -g root -m 0600 -D "${g10s_onlinebackupDir}/up.conf" /etc/up.conf
    install -o root -g root -m 0600 -D "${g10s_onlinebackupDir}/user_cfg.xml" /etc/user_cfg.xml

    return 0
}


if [ "$1" = "rollback" ]
then
    t91s_rollback
elif [ "$1" = "backup" ]
then
    t91s_backup
elif [ "$1" = "removeconf" ]
then
    t91s_removeconf
elif [ "$1" = "copyconf" ]
then
    t91s_copyconf
else
    print_error "1005" "unknown parameter[$1]"
    t90s_useage
fi
