#!/bin/bash

DATE="`date +"%Y_%m_%d_%H_%M_%S"`"
NAME_XMP_LOG="${DATE}_xmp_log.tar"
NAME_XMP_LOG_GZ="${NAME_XMP_LOG}.gz"

NAME_HISTORY_ALARM_LOG="${DATE}_history_alarm_log.tar"
NAME_HISTORY_ALARM_LOG_GZ="${NAME_HISTORY_ALARM_LOG}.gz"

NAME_CLI_UIL_LOG="${DATE}_cli_uil_log.tar"
NAME_CLI_UIL_LOG_GZ="${NAME_CLI_UIL_LOG}.gz"

NAME_UPADM_LOG="${DATE}_upadm_log.tar"
NAME_UPADM_LOG_GZ="${NAME_UPADM_LOG}.gz"

NAME_CLI_OPERATE_LOG="${DATE}_cli_operate_log.tar"
NAME_CLI_OPERATE_LOG_GZ="${NAME_CLI_OPERATE_LOG}.gz"

NAME_OPER_LOG="${DATE}_oper_log.tar"
NAME_OPER_LOG_GZ="${NAME_OPER_LOG}.gz"

NAME_INSTALL_LOG="${DATE}_install_log.tar"
NAME_INSTALL_LOG_GZ="${NAME_INSTALL_LOG}.gz"

NAME_OUC_LOG="${DATE}_ouc_log.tar"
NAME_OUC_LOG_GZ="${NAME_INSTALL_LOG}.gz"

NAME_CFG_UP_LOG="${DATE}_cfg_upgrade.tar"
NAME_CFG_UP_GZ="${NAME_INSTALL_LOG}.gz"

NAME_PERF_RECORD_LOG="${DATE}_perf_record.tar"
NAME_PERF_RECORD_GZ="${NAME_PERF_RECORD_LOG}.gz"


SIZE="1"
SIZE_30M="31457280"
SIZE_180M="184320"
SIZE_200M="204800"
SIZE_500M="512000"
SIZE_600M="614400"
SIZE_4G="4194304"
XMP_FLAG=0
UIL_FLAG=0
OPER_FLAG=0
ULTOOLS_FLAG=0
PERF_FLAG=0

ULTRAPATH_LOG_DIR="/opt/UltraPath/log"
ALARM_LOG_DIR="/opt/UltraPath/log/alarm_log"
KERNEL_LOG_DIR="/opt/UltraPath/log/kernel_log"
UIL_LOG_DIR="/opt/UltraPath/log/uil_log"
OPERATE_LOG_DIR="/opt/UltraPath/log/operate_log"
INSTALL_LOG_DIR="/opt/UltraPath/log/install_log"
PERF_RECORD_DIR="/opt/UltraPath/log/perf_record"

function RmLogExceedSize()
{
    local LOG_DIR=$1
    local MAX_SIZE=$2
    local cur_size=0
    
    if [ ! -d $LOG_DIR ]
    then
        echo "The directory[$LOG_DIR] isn't exist."
        return 1
    fi
    
    cur_size=`du -sk ${LOG_DIR}|awk '{print $1}'`
    if [ "$cur_size" -gt "$MAX_SIZE" ]
    then
        file_list=`ls -rt ${LOG_DIR}/`
        for file_name in $file_list
        do
            rm -rf ${LOG_DIR}/${file_name} > /dev/null 2>&1
            cur_size=`du -sk ${LOG_DIR}|awk '{print $1}'`
            if [ "$cur_size" -le "$MAX_SIZE" ]
            then
                break
            fi
        done
    fi
    return 0
}

function RmLogForMoreSpace()
{
    local LOG_DIR=$1
    local MAX_SIZE=$2
    local FLAG=$3
    
    if [ ! -d ${LOG_DIR} ]
    then
        return 1
    fi
    
    if [ `du -sk ${LOG_DIR}|awk '{print $1}'` -gt "${MAX_SIZE}" ]
    then
        RmLogExceedSize "${LOG_DIR}" "${MAX_SIZE}"
    elif [ "${FLAG}" -eq 1 ]
    then
        filename=`ls -rt ${LOG_DIR} | head -n 1`
        rm -rf ${LOG_DIR}/${filename} > /dev/null 2>&1
    fi
}

if [ -f ${ULTRAPATH_LOG_DIR}/cur_index ]; then
	index="`cat ${ULTRAPATH_LOG_DIR}/cur_index`"
	var=`echo ${index:0:1}`
	case $var in
	"0")
    	        LOG1_FILE="xmp_log1.txt"
		LOG2_FILE="xmp_log2.txt"
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG1_FILE} ]; then
			SIZE1=1
		else
			SIZE1=0
		fi
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG2_FILE} ]; then
			SIZE2=1
		else
			SIZE2=0
		fi
		;;
	"1")
		LOG1_FILE="xmp_log0.txt"
		LOG2_FILE="xmp_log2.txt"
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG1_FILE} ]; then
			SIZE1=1
		else
			SIZE1=0
		fi
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG2_FILE} ]; then
			SIZE2=1
		else
			SIZE2=0
		fi
		;;
	"2")
		LOG1_FILE="xmp_log0.txt"
		LOG2_FILE="xmp_log1.txt"
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG1_FILE} ]; then
			SIZE1=1
		else
			SIZE1=0
		fi
		if [ -f ${ULTRAPATH_LOG_DIR}/${LOG2_FILE} ]; then
			SIZE2=1
		else
			SIZE2=0
		fi
		;;
	*)
		SIZE1=0
		SIZE2=0
	esac
	
	size=`expr $SIZE1 + $SIZE2`
	
	if [ ${size} -ge ${SIZE} ]; then
		if [ ! -d ${KERNEL_LOG_DIR} ]; then
			mkdir ${KERNEL_LOG_DIR}
			chmod 700 ${KERNEL_LOG_DIR}
		fi
		if [ ${SIZE1} -eq "1" ]; then
		    mv ${ULTRAPATH_LOG_DIR}/${LOG1_FILE} ${KERNEL_LOG_DIR}/${LOG1_FILE}
		fi
		if [ ${SIZE2} -eq "1" ]; then
		    mv ${ULTRAPATH_LOG_DIR}/${LOG2_FILE} ${KERNEL_LOG_DIR}/${LOG2_FILE}
		fi
		echo "Compressing XMP log ... "
		if [ ${SIZE1} -eq "1" ]; then
		    if [ ${SIZE2} -eq "1" ]; then
		        tar -cvf  ${KERNEL_LOG_DIR}/${NAME_XMP_LOG}  ${KERNEL_LOG_DIR}/${LOG1_FILE}  ${KERNEL_LOG_DIR}/${LOG2_FILE}
		    else
		        tar -cvf  ${KERNEL_LOG_DIR}/${NAME_XMP_LOG}  ${KERNEL_LOG_DIR}/${LOG1_FILE}
		    fi
		elif [ ${SIZE2} -eq "1" ]; then
		   tar -cvf  ${KERNEL_LOG_DIR}/${NAME_XMP_LOG}  ${KERNEL_LOG_DIR}/${LOG2_FILE}
		fi 
		gzip ${KERNEL_LOG_DIR}/${NAME_XMP_LOG}
		chmod 600 ${KERNEL_LOG_DIR}/${NAME_XMP_LOG_GZ}
		if [ ${SIZE1} -eq "1" ]; then
		    rm -f ${KERNEL_LOG_DIR}/${LOG1_FILE}
		fi
		if [ ${SIZE2} -eq "1" ]; then
		    rm -f ${KERNEL_LOG_DIR}/${LOG2_FILE}
		fi
        XMP_FLAG=1
	fi
fi


if [ -f ${ULTRAPATH_LOG_DIR}/history_alarm ]; then
	LOOP=0
	cat ${ULTRAPATH_LOG_DIR}/history_alarm | while read line
	do
    	LOOP=`expr $LOOP + 1`
    	if [ $LOOP -ge 100 ]; then
    	    if [ ! -d ${ALARM_LOG_DIR} ]; then
    	        mkdir ${ALARM_LOG_DIR}
    	        chmod 700 ${ALARM_LOG_DIR}
    	    fi
        	echo "Compressing history alarm log ... "
	        cp ${ULTRAPATH_LOG_DIR}/history_alarm ${ALARM_LOG_DIR}/history_alarm
        	cd ${ALARM_LOG_DIR}/
                tar -cvf ${ALARM_LOG_DIR}/${NAME_HISTORY_ALARM_LOG} history_alarm
		gzip ${ALARM_LOG_DIR}/${NAME_HISTORY_ALARM_LOG}
		chmod 600 ${ALARM_LOG_DIR}/${NAME_HISTORY_ALARM_LOG_GZ}
        	rm ${ALARM_LOG_DIR}/history_alarm
			    >${ULTRAPATH_LOG_DIR}/history_alarm
        	echo "Compress successfull."
        	break;
    	fi
	done
fi


if [ -f ${ULTRAPATH_LOG_DIR}/cli_uil_log.txt ]; then
	SIZE_UIL_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep cli_uil_log.txt | awk '/cli_uil_log.txt$/{print $5}'`"
	if [ ${SIZE_UIL_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${UIL_LOG_DIR} ]; then
			mkdir ${UIL_LOG_DIR}
			chmod 700 ${UIL_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/cli_uil_log.txt ${UIL_LOG_DIR}/cli_uil_log.txt
		>${ULTRAPATH_LOG_DIR}/cli_uil_log.txt
		cd ${UIL_LOG_DIR}/
		tar -cvf  ${NAME_CLI_UIL_LOG}  cli_uil_log.txt
		gzip ${NAME_CLI_UIL_LOG}
		rm -rf cli_uil_log.txt
		chmod 600 ${NAME_CLI_UIL_LOG_GZ}
        UIL_FLAG=1
	fi	
fi


if [ -f ${ULTRAPATH_LOG_DIR}/upadm_log.txt ]; then
	SIZE_UPADM_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep upadm_log.txt | awk '/upadm_log.txt$/{print $5}'`"
	if [ ${SIZE_UPADM_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${UIL_LOG_DIR} ]; then
			mkdir ${UIL_LOG_DIR}
			chmod 700 ${UIL_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/upadm_log.txt ${UIL_LOG_DIR}/upadm_log.txt
		>${ULTRAPATH_LOG_DIR}/upadm_log.txt
		tar -cvf  ${UIL_LOG_DIR}/${NAME_UPADM_LOG}  ${UIL_LOG_DIR}/upadm_log.txt
		gzip ${UIL_LOG_DIR}/${NAME_UPADM_LOG}
		rm -rf ${UIL_LOG_DIR}/upadm_log.txt
		chmod 600 ${UIL_LOG_DIR}/${NAME_UPADM_LOG_GZ}
        UIL_FLAG=1
	fi
fi


if [ -f ${ULTRAPATH_LOG_DIR}/cli_operate_log.txt ]; then
	SIZE_CLI_OPERATE_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep cli_operate_log.txt | awk '/cli_operate_log.txt$/{print $5}'`"
	if [ ${SIZE_CLI_OPERATE_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${OPERATE_LOG_DIR} ]; then
			mkdir ${OPERATE_LOG_DIR}
			chmod 700 ${OPERATE_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/cli_operate_log.txt ${OPERATE_LOG_DIR}/cli_operate_log.txt
		>${ULTRAPATH_LOG_DIR}/cli_operate_log.txt
		tar -cvf  ${OPERATE_LOG_DIR}/${NAME_CLI_OPERATE_LOG}  ${OPERATE_LOG_DIR}/cli_operate_log.txt
		gzip ${OPERATE_LOG_DIR}/${NAME_CLI_OPERATE_LOG}
		rm -rf ${OPERATE_LOG_DIR}/cli_operate_log.txt
		chmod 600 ${OPERATE_LOG_DIR}/${NAME_CLI_OPERATE_LOG_GZ}
        OPER_FLAG=1
	fi	
fi


if [ -f ${ULTRAPATH_LOG_DIR}/oper_log ]; then
	SIZE_OPER_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep "oper_log" | awk '$9=="oper_log" {print $5}'`"
	if [ ${SIZE_OPER_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${OPERATE_LOG_DIR} ]; then
			mkdir ${OPERATE_LOG_DIR}
			chmod 700 ${OPERATE_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/oper_log ${OPERATE_LOG_DIR}/oper_log
		>${ULTRAPATH_LOG_DIR}/oper_log
		tar -cvf  ${OPERATE_LOG_DIR}/${NAME_OPER_LOG}  ${OPERATE_LOG_DIR}/oper_log
		gzip ${OPERATE_LOG_DIR}/${NAME_OPER_LOG}
		rm -rf ${OPERATE_LOG_DIR}/oper_log
		chmod 600 ${OPERATE_LOG_DIR}/${NAME_OPER_LOG_GZ}
        OPER_FLAG=1
	fi	
fi


if [ -f ${ULTRAPATH_LOG_DIR}/ultrapathTool.log ]; then
	SIZE_INSTALL_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep "ultrapathTool.log" | awk '$9=="ultrapathTool.log" {print $5}'`"
	if [ ${SIZE_INSTALL_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${INSTALL_LOG_DIR} ]; then
			mkdir ${INSTALL_LOG_DIR}
			chmod 700 ${INSTALL_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/ultrapathTool.log ${INSTALL_LOG_DIR}/ultrapathTool.log
		>${ULTRAPATH_LOG_DIR}/ultrapathTool.log
		tar -cvf  ${INSTALL_LOG_DIR}/${NAME_INSTALL_LOG}  ${INSTALL_LOG_DIR}/ultrapathTool.log
		gzip ${INSTALL_LOG_DIR}/${NAME_INSTALL_LOG}
		rm -rf ${INSTALL_LOG_DIR}/ultrapathTool.log
		chmod 600 ${INSTALL_LOG_DIR}/${NAME_INSTALL_LOG_GZ}
        ULTOOLS_FLAG=1
	fi	
fi

if [ -f ${ULTRAPATH_LOG_DIR}/perf_record.log ]; then
	SIZE_PERF_RECORD_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep "perf_record.log" | awk '$9=="perf_record.log" {print $5}'`"
	if [ ${SIZE_PERF_RECORD_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${PERF_RECORD_DIR} ]; then
			mkdir ${PERF_RECORD_DIR}
			chmod 700 ${PERF_RECORD_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/perf_record.log ${PERF_RECORD_DIR}/perf_record.log
		>${ULTRAPATH_LOG_DIR}/perf_record.log
		tar -cvf  ${PERF_RECORD_DIR}/${NAME_PERF_RECORD_LOG}  ${ULTRAPATH_LOG_DIR}/perf_record.log
		gzip ${PERF_RECORD_DIR}/${NAME_PERF_RECORD_LOG}
		rm -rf ${PERF_RECORD_DIR}/perf_record.log
		chmod 600 ${PERF_RECORD_DIR}/${NAME_PERF_RECORD_GZ}
        PERF_FLAG=1
	fi	
fi

if [ -f ${ULTRAPATH_LOG_DIR}/ouc_log.txt ]; then
	SIZE_INSTALL_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep "ouc_log.txt" | awk '$9=="ouc_log.txt" {print $5}'`"
	if [ ${SIZE_INSTALL_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${INSTALL_LOG_DIR} ]; then
			mkdir ${INSTALL_LOG_DIR}
			chmod 700 ${INSTALL_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/ouc_log.txt ${INSTALL_LOG_DIR}/ouc_log.txt
		>${ULTRAPATH_LOG_DIR}/ouc_log.txt
		tar -cvf  ${INSTALL_LOG_DIR}/${NAME_OUC_LOG}  ${INSTALL_LOG_DIR}/ouc_log.txt
		gzip ${INSTALL_LOG_DIR}/${NAME_OUC_LOG}
		rm -rf ${INSTALL_LOG_DIR}/ouc_log.txt
		chmod 600 ${INSTALL_LOG_DIR}/${NAME_OUC_LOG_GZ}
        ULTOOLS_FLAG=1
	fi	
fi


if [ -f ${ULTRAPATH_LOG_DIR}/cfg_upgrade ]; then
	SIZE_INSTALL_LOG="`ls -l ${ULTRAPATH_LOG_DIR} | grep "cfg_upgrade" | awk '$9=="cfg_upgrade" {print $5}'`"
	if [ ${SIZE_INSTALL_LOG} -ge ${SIZE_30M} ]; then
		if [ ! -d ${INSTALL_LOG_DIR} ]; then
			mkdir ${INSTALL_LOG_DIR}
			chmod 700 ${INSTALL_LOG_DIR}
		fi
		cp ${ULTRAPATH_LOG_DIR}/cfg_upgrade ${INSTALL_LOG_DIR}/cfg_upgrade
		>${ULTRAPATH_LOG_DIR}/cfg_upgrade
		tar -cvf  ${INSTALL_LOG_DIR}/${NAME_CFG_UP_LOG}  ${INSTALL_LOG_DIR}/cfg_upgrade
		gzip ${INSTALL_LOG_DIR}/${NAME_CFG_UP_LOG}
		rm -rf ${INSTALL_LOG_DIR}/cfg_upgrade
		chmod 600 ${INSTALL_LOG_DIR}/${NAME_CFG_UP_GZ}
        ULTOOLS_FLAG=1
	fi	
fi

if [ -d ${KERNEL_LOG_DIR} ]; then
    find ${KERNEL_LOG_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

if [ -d ${ALARM_LOG_DIR} ]; then
    find ${ALARM_LOG_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

if [ -d ${UIL_LOG_DIR} ]; then
    find ${UIL_LOG_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

if [ -d ${OPERATE_LOG_DIR} ]; then
    find ${OPERATE_LOG_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

if [ -d ${INSTALL_LOG_DIR} ]; then
    find ${INSTALL_LOG_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

if [ -d ${PERF_RECORD_DIR} ]; then
    find ${PERF_RECORD_DIR} -name *.tar.gz -mtime +365 -exec rm {} \;
fi

freeSpace=`df -k "/opt" 2>/dev/null | sed -n '$p' | grep ".*[[:blank:]][[:blank:]]*[0-9][0-9]*[[:blank:]][[:blank:]]*[0-9][0-9]*%[[:blank:]][[:blank:]]*/.*$" | awk '{print $(NF-2)}'`
totalSpace=0
tmpSpace=0
if [ -d ${KERNEL_LOG_DIR} ]; then
    tmpSpace=`du -sk ${KERNEL_LOG_DIR} | awk '{print $1}'`
    let totalSpace=totalSpace+tmpSpace
fi

if [ -d ${UIL_LOG_DIR} ]; then
    tmpSpace=`du -sk ${UIL_LOG_DIR} | awk '{print $1}'`
    let totalSpace=totalSpace+tmpSpace
fi

if [ -d ${OPERATE_LOG_DIR} ]; then
    tmpSpace=`du -sk ${OPERATE_LOG_DIR} | awk '{print $1}'`
    let totalSpace=totalSpace+tmpSpace
fi

if [ -d ${INSTALL_LOG_DIR} ]; then
    tmpSpace=`du -sk ${INSTALL_LOG_DIR} | awk '{print $1}'`
    let totalSpace=totalSpace+tmpSpace
fi

if [ -d ${PERF_RECORD_DIR} ]; then
    tmpSpace=`du -sk ${PERF_RECORD_DIR} | awk '{print $1}'`
    let totalSpace=totalSpace+tmpSpace
fi

if [ ${freeSpace} -lt ${SIZE_180M} ] || [ ${totalSpace} -gt ${SIZE_4G} ]
then
    RmLogForMoreSpace ${KERNEL_LOG_DIR} ${SIZE_500M} ${XMP_FLAG}
    RmLogForMoreSpace ${UIL_LOG_DIR} ${SIZE_200M} ${UIL_FLAG}
    RmLogForMoreSpace ${OPERATE_LOG_DIR} ${SIZE_200M} ${OPER_FLAG}
    RmLogForMoreSpace ${INSTALL_LOG_DIR} ${SIZE_200M} ${ULTOOLS_FLAG}
    RmLogForMoreSpace ${PERF_RECORD_DIR} ${SIZE_600M} ${PERF_FLAG}
fi

if [ -d /var/log/UltraPath ]
then
     chmod -R 600 /var/log/UltraPath
else
     chmod  -R 600 /opt/UltraPath/log
fi

